#include "picture.h"
#include "ui_picture.h"

#include <QApplication>
#include <QFileDialog>
#include <QImageReader>
#include <QPainter>

void run (QImage & image);
void move (QImage & image);

MainWindow::MainWindow(QWidget *parent) :
    QMainWindow(parent),
    ui(new Ui::MainWindow)
{
    ui->setupUi(this);
    loadImage ("../picture/earth.png");
}

MainWindow::~MainWindow()
{
    delete ui;
}

void MainWindow::loadImage (QString fileName)
{
    QPixmap pixmap;
    pixmap.load (fileName);
    ui->imageLabel->setPixmap (pixmap);
}

void MainWindow::on_actionOpen_triggered()
{
   QString fileName = QFileDialog::getOpenFileName (this, "Open Image");
   if (! fileName.isNull())
   {
       loadImage (fileName);

       /*
       QImageReader reader (fileName);
       reader.setAutoTransform(true);
       const QImage image = reader.read();
       if (! image.isNull ())
       {
           QPixmap pixmap = QPixmap::fromImage (image);
           ui->imageLabel->setPixmap (pixmap);
       }
       */
   }
}

void MainWindow::on_actionRun_triggered()
{
    const QPixmap * pixmap = ui->imageLabel->pixmap ();
    QImage image = pixmap->toImage();
    run (image);
    QPixmap pixmap2 = QPixmap::fromImage (image);
    ui->imageLabel->setPixmap (pixmap2);
}

void MainWindow::on_actionMove_triggered()
{
    const QPixmap * pixmap = ui->imageLabel->pixmap ();
    QImage image = pixmap->toImage();
    ::move (image);
    QPixmap pixmap2 = QPixmap::fromImage (image);
    ui->imageLabel->setPixmap (pixmap2);
}

int main(int argc, char *argv[])
{
    QApplication a(argc, argv);
    MainWindow w;
    w.show();

    return a.exec();
}

void run (QImage & image)
{
    int w = image.width ();
    int h = image.height ();

    QPainter painter (& image);

    painter.setPen (QColor ("red"));
    painter.drawRect (0, 0, w-1, h-1);

    painter.setPen (QColor ("blue"));
    painter.drawEllipse (1, 1, w-2, h-2);

    painter.setPen (QColor ("orange"));
    QFont font = painter.font();
    font.setPixelSize (48);
    painter.setFont(font);
    painter.drawText (w/4, h/2, "Earth");
    // painter.drawText (0, 0, w, h, Qt::AlignCenter | Qt::AlignHCenter, "Earth");

    image.setPixel (4, 4, qRgb (0, 255, 0));
}

void move (QImage & image)
{
    int w = image.width ();
    int h = image.height ();
    for (int i = 0; i < h; i++)
    {
        for (int j = 0; j < w; j++)
        {
            QRgb data = image.pixel (i, j);
            if (i >= 10)
               image.setPixel (i-10, j, data);
        }
    }
}
